@import '../theme/theme.scss';
@import '../variables.module.scss';

/*
	SASS variables
	When possible, prefer css vars, but e.g. breakpoints can only be set with sass	

	Import this stylesheet in e.g. svelte components that need to make media queries or use the mixins defined below.

*/

// font sizes and spacing

@mixin base-font {
  @include font-style(base);
  @include font-size(m);
}

@mixin heading-font {
  @include font-style(heading);
}

// e.g. apply font style decoration
// font-style default will set line-height to --font-style-default-line-height etc.
@mixin font-style($variation: base) {
  font: var(--font-style-#{$variation});
  text-decoration: none;
}

@mixin font-size($size: m) {
  font-size: var(--font-size-#{$size});
}

// card, hover, modal
@mixin shadow($type: card) {
  box-shadow: var(--effect-depth-#{$type}-color) var(--effect-depth-#{$type}-offset-x)
    var(--effect-depth-#{$type}-offset-y) var(--effect-depth-#{$type}-radius);
}

@mixin color-theme($theme: light) {
  color-scheme: #{$theme};

  --color-foreground-base: var(--color-#{$theme}-foreground-base);
  --color-foreground-weaker: var(--color-#{$theme}-foreground-weaker);
  --color-foreground-weakest: var(--color-#{$theme}-foreground-weakest);
  --color-background-base: var(--color-#{$theme}-background-base);
  --color-background-weaker: var(--color-#{$theme}-background-weaker);
  --color-background-weakest: var(--color-#{$theme}-background-weakest);
  --color-model-aspect-climate: var(--color-#{$theme}-model-aspect-climate);
  --color-model-aspect-scope-conditions: var(--color-#{$theme}-model-aspect-scope-conditions);
  --color-model-aspect-conflict: var(--color-#{$theme}-model-aspect-conflict);

  --color-category-0: var(--color-#{$theme}-category-0);
  --color-category-1: var(--color-#{$theme}-category-1);
  --color-category-2: var(--color-#{$theme}-category-2);
  --color-category-3: var(--color-#{$theme}-category-3);
  --color-category-4: var(--color-#{$theme}-category-4);
  --color-category-5: var(--color-#{$theme}-category-5);
  --color-diverging-positive-2: var(--color-#{$theme}-diverging-positive-2);
  --color-diverging-positive-1: var(--color-#{$theme}-diverging-positive-1);
  --color-diverging-neutral: var(--color-#{$theme}-diverging-neutral);
  --color-diverging-negative-1: var(--color-#{$theme}-diverging-negative-1);
  --color-diverging-negative-2: var(--color-#{$theme}-diverging-negative-2);

  --color-brand-base: var(--color-#{$theme}-brand-base);
  --color-brand-stronger: var(--color-#{$theme}-brand-stronger);
  --color-brand-weaker: var(--color-#{$theme}-brand-weaker);
  --color-brand-weakest: var(--color-#{$theme}-brand-weakest);

  --color-functional-accent: var(--color-#{$theme}-functional-accent);
  --color-functional-filtered-out: var(--color-#{$theme}-functional-filtered-out);
  --color-functional-not-available: var(--color-#{$theme}-functional-not-available);
  --color-selection-stroke: var(--color-#{$theme}-selection-stroke);
  --color-selection-fill: var(--color-#{$theme}-selection-fill);

  --color-sequential-0: var(--color-#{$theme}-sequential-0);
  --color-sequential-1: var(--color-#{$theme}-sequential-1);
  --color-sequential-2: var(--color-#{$theme}-sequential-2);
  --color-sequential-3: var(--color-#{$theme}-sequential-3);

  --color-text-weaker: var(--color-#{$theme}-text-weaker);
  --color-text-base: var(--color-#{$theme}-text-base);

  @each $name in $colors-sectors {
    --color-sectors-#{$name}: var(--color-#{$theme}-sectors-#{$name});
  }

  @each $name in $colors-energy-sources {
    --color-energy-sources-#{$name}: var(--color-#{$theme}-energy-sources-#{$name});
  }
  
  @each $name in $colors-gases {
    --color-gases-#{$name}: var(--color-#{$theme}-gases-#{$name});
  }

  @each $name in $colors-emissions {
    --color-emissions-#{$name}: var(--color-#{$theme}-emissions-#{$name});
  }

  @if #{$theme} == 'light' {
    --blend-mode: multiply;
  }
  @if #{$theme} == 'dark' {
    --blend-mode: screen;
  }
}

@mixin border-radius() {
  border-radius: calc(var(--size-border-radius) * 1px);
}

@mixin button {
  @include base-font();
  @include shadow(ui);
  @include border-radius();

  padding: var(--space-xxs) var(--space-s);
  background-color: var(--color-background-base);

  border: 1px solid var(--color-foreground-weaker);

  cursor: pointer;

  transition: transform, border, background, color;
  transition-duration: var(--duration-ui);

  &:hover {
    border: 1px solid var(--color-foreground-base);
    // transform: scale(1.02);
    // @include shadow(hover);
  }

  &:active {
    transform: scale(0.98);
  }

  &:disabled {
    box-shadow: none;
    border-color: var(--color-foreground-weakest);
    color: var(--color-text-weaker);
    pointer-events: none;
  }
}

@mixin color($color: theme) {
  color: var(--color-#{$color});
}

@mixin padding($size: m) {
  padding: var(--space-#{$size});
}

@mixin margin($size: m) {
  margin: var(--space-#{$size});
}

@mixin gap($size: m) {
  gap: var(--space-#{$size});
  grid-gap: var(--space-#{$size});
}

@mixin bold {
  font-weight: var(--font-font-weight-bold-number);
}

@mixin gridline {
  stroke: var(--color-foreground-weakest);
  fill: none;
  stroke-dasharray: 1.5 1.5;
}

.gridline {
  @include gridline;
}

@mixin gridline-thin {
  stroke: var(--color-foreground-weakest);
  fill: none;
  opacity: 0.33;
}
.gridline-thin {
  @include gridline-thin;
}


// RESPONSIVE MIXINS
@mixin smaller-than-xs {
  @media screen and (max-width: $size-breakpoint-xs) {
    @content;
  }
}

@mixin smaller-than-s {
  @media screen and (max-width: $size-breakpoint-s) {
    @content;
  }
}

@mixin smaller-than-m {
  @media screen and (max-width: $size-breakpoint-m) {
    @content;
  }
}

@mixin smaller-than-l {
  @media screen and (max-width: $size-breakpoint-l) {
    @content;
  }
}

@mixin smaller-than-xl {
  @media screen and (max-width: $size-breakpoint-xl) {
    @content;
  }
}

@mixin larger-than-xs {
  @media screen and (min-width: $size-breakpoint-xs) {
    @content;
  }
}

@mixin larger-than-s {
  @media screen and (min-width: $size-breakpoint-s) {
    @content;
  }
}

@mixin larger-than-m {
  @media screen and (min-width: $size-breakpoint-m) {
    @content;
  }
}

@mixin larger-than-l {
  @media screen and (min-width: $size-breakpoint-l) {
    @content;
  }
}

@mixin larger-than-xl {
  @media screen and (min-width: $size-breakpoint-xl) {
    @content;
  }
}


%buttonReset {
  border: none;
  background: transparent;
  cursor: pointer;
  font-family: var(--font-font-family-base);
}

%smootScroll {
  scroll-behavior: smooth;

  @media (prefers-reduced-motion) {
    scroll-behavior: initial;
  }
}

%columnBreakHack {
  // Hack to avoid page break right after heading
  &::after {
    content: '';
    display: block;
    height: 100px;
    margin-bottom: -100px;
  }
}

@mixin text-border($color: white, $width: 1.5px) {
  text-shadow: -#{$width} -#{$width} 0 $color, 0 -#{$width} 0 $color, $width -#{$width} 0 $color,
    $width 0 0 $color, $width $width 0 $color, 0 $width 0 $color, -#{$width} $width 0 $color,
    -#{$width} 0 0 $color, -#{$width} -#{$width} 1px $color, 0 -#{$width} 1px $color,
    $width -#{$width} 1px $color, $width 0 1px $color, $width $width 1px $color,
    1px $width 1px $color, -#{$width} $width 1px $color, -#{$width} 0 1px $color;
}
